﻿Imports Microsoft.VisualBasic.ApplicationServices
Imports System.Text.RegularExpressions
Namespace My
    Partial Friend Class MyApplication
        ''' <summary>
        ''' Indicates if we are running under the IDE or not
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public ReadOnly Property RunningUnderDebugger() As Boolean
            Get
                Return System.Diagnostics.Debugger.IsAttached
            End Get
        End Property
        Private mContinueAfterException As Boolean
        ''' <summary>
        ''' Determine if this app can stay open after an unhandled
        ''' exception has been thrown.
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks>
        ''' Not practical in most circumstances as we usually
        ''' do not know how to hangle unhandled exceptions and
        ''' leaving an app open will not be wise.
        ''' </remarks>
        Public Property ContinueAfterException() As Boolean
            Get
                Return Not mContinueAfterException
            End Get
            Set(ByVal value As Boolean)
                mContinueAfterException = value
            End Set
        End Property
        ''' <summary>
        ''' Displays a user friendly message in regards to the 
        ''' unhandled exception.
        ''' </summary>
        ''' <param name="sender"></param>
        ''' <param name="e"></param>
        ''' <remarks>
        ''' It would be wise to also write to a log file etc.
        ''' 
        ''' WARNING 
        ''' If you use code prone to errors in here then you will not 
        ''' be very happy so test test test before implementing.
        ''' </remarks>
        Private Sub MyApplication_UnhandledException( _
            ByVal sender As Object, _
            ByVal e As UnhandledExceptionEventArgs) _
        Handles Me.UnhandledException

            Dim Doc As New XDocument
            Dim FileName As String = "unhandledExceptions.xml"

            If IO.File.Exists(FileName) Then
                Doc = XDocument.Load(FileName)
            Else
                Doc = XDocument.Parse( _
                "<?xml version=""1.0"" encoding=""utf-8""?><Exceptions></Exceptions>")
            End If

            Dim config = Doc.<Exceptions>(0)
            Dim StackTraceText As String = e.Exception.StackTrace.ToString

            config.Add( _
            <Exception>
                <Date_Time><%= Now.ToShortDateString & " " & Now.ToShortTimeString %></Date_Time>
                <Message><%= e.Exception.Message %></Message>
                <StackTrace><%= Environment.NewLine %>
                    <%= StackTraceText %><%= Environment.NewLine %>
                </StackTrace>
            </Exception>)

            config.Save(FileName)

            '
            ' Select one of the messsagebox below
            '

            'MessageBox.Show(String.Format("Exception{0}{1}{0}See log file{0}{2}", Environment.NewLine, e.Exception.Message, FileName))
            MessageBox.Show("Encountered an error, please contact your help desk.")

            e.ExitApplication = Me.ContinueAfterException

        End Sub
    End Class
End Namespace


